VERSION 2.00
Begin Form VidOpt 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Copy Video Options"
   ClientHeight    =   3810
   ClientLeft      =   2115
   ClientTop       =   1440
   ClientWidth     =   3015
   Height          =   4215
   HelpContextID   =   135
   Left            =   2055
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3810
   ScaleWidth      =   3015
   Top             =   1095
   Width           =   3135
   Begin CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   540
      HelpContextID   =   135
      Left            =   855
      TabIndex        =   7
      Top             =   3075
      Width           =   1230
   End
   Begin Frame fraReplace 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Data Option:"
      Height          =   990
      HelpContextID   =   135
      Left            =   315
      TabIndex        =   3
      Top             =   1875
      Width           =   2220
      Begin OptionButton optReplace 
         Caption         =   "Replace data"
         Height          =   315
         HelpContextID   =   135
         Left            =   135
         TabIndex        =   5
         Top             =   600
         Width           =   1770
      End
      Begin OptionButton optAppend 
         Caption         =   "Append data"
         Height          =   315
         HelpContextID   =   135
         Left            =   135
         TabIndex        =   4
         Top             =   300
         Value           =   -1  'True
         Width           =   1770
      End
   End
   Begin CheckBox chkRating 
      Caption         =   "Copy Rating Records"
      Height          =   315
      HelpContextID   =   135
      Left            =   405
      TabIndex        =   2
      Top             =   1500
      Width           =   2220
   End
   Begin CheckBox chkGenre 
      Caption         =   "Copy Genre Records"
      Height          =   315
      HelpContextID   =   135
      Left            =   405
      TabIndex        =   1
      Top             =   1125
      Width           =   2220
   End
   Begin CheckBox chkVideo 
      Caption         =   "Copy Video Records"
      Height          =   315
      HelpContextID   =   135
      Left            =   405
      TabIndex        =   0
      Top             =   750
      Width           =   2220
   End
   Begin Label lblTitle 
      AutoSize        =   -1  'True
      Caption         =   "Set Copy Options"
      FontBold        =   -1  'True
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   13.5
      FontStrikethru  =   0   'False
      FontUnderline   =   -1  'True
      Height          =   300
      Left            =   405
      TabIndex        =   6
      Top             =   225
      Width           =   2070
   End
End
' Subsystem: Copy
' Module:    VidOpt.Frm
' Date:      01/01/94
' Author:    Richard Stauch
' Notes:
' This form gives the user an opportunity to select the
' files and tables they want to copy, and if they want to
' clear the "To" table first.

Option Explicit
DefInt A-Z

Sub chkGenre_Click ()
' Toggle the Genre-Copy variable.
  Select Case chkGenre.Value
    Case UNCHECKED
    ' Do not copy.
      GenreCopy% = False
    Case CHECKED
    ' Copy.
      GenreCopy% = True
    Case GRAYED
    ' Do nothing.
  End Select
End Sub

Sub chkRating_Click ()
' Toggle the Rating-Copy variable.
  Select Case chkRating.Value
    Case UNCHECKED
    ' Do not copy.
      RatingCopy% = False
    Case CHECKED
    ' Copy.
      RatingCopy% = True
    Case GRAYED
    ' Do nothing.
  End Select
End Sub

Sub chkVideo_Click ()
' Toggle the Video-Copy variable.
  Select Case chkVideo.Value
    Case UNCHECKED
    ' Do not copy.
      VideoCopy% = False
    Case CHECKED
    ' Copy.
      VideoCopy% = True
    Case GRAYED
    ' Do nothing.
  End Select
End Sub

Sub cmdOK_Click ()
' Remove the VidOpt form from the screen.
  Unload VidOpt
End Sub

Sub Form_Load ()
' Display the form, and select/unselect boxes.
' Notes:
' Setting the values in these check boxes and option buttons
' generates Click events for them, automatically setting the
' associated variables.
  If GenreCopy% = True Then
  ' Copy Genre table.
    chkGenre = CHECKED
  Else
    chkGenre = UNCHECKED
  End If
  If RatingCopy% = True Then
  ' Copy Rating table.
    chkRating = CHECKED
  Else
    chkRating = UNCHECKED
  End If
  If VideoCopy% = True Then
  ' Copy Video table.
    chkVideo = CHECKED
  Else
    chkVideo = UNCHECKED
  End If
  If ReplaceData% = True Then
  ' Set Replace option.
    optReplace = True
  Else
    optAppend = True
  End If
End Sub

Sub optAppend_Click ()
' Do not replace existing data.
  ReplaceData% = False
End Sub

Sub optReplace_Click ()
' Replace data.
  ReplaceData% = True
End Sub

